/***************************************************************************

  BionxControl
  Copyright © 2025 christoph holzheuer
  christoph.holzheuer@gmail.com

  Using:

  mhs_can_drv.c
  © 2011 - 2023 by MHS-Elektronik GmbH & Co. KG, Germany
  Klaus Demlehner, klaus@mhs-elektronik.de
  @see www.mhs-elektronik.de

  Based on Bionx data type descriptions from:

  BigXionFlasher USB V 0.2.4 rev. 97
  © 2011-2013 by Thomas Koenig <info@bigxionflasher.org>
  @see www.bigxionflasher.org

  Bionx Bike Info
  © 2018 Thorsten Schmidt (tschmidt@ts-soft.de)
  @see www.ts-soft.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  @see https://github.com/bikemike/bionx-bikeinfo

 ***************************************************************************/


#ifndef BCMAINWINDOW_H
#define BCMAINWINDOW_H

#include <QMainWindow>

#include <ui_bcmainwindow.h>
#include <bcdatamanager.h>

class BCDeviceView;

class BCMainWindow : public QMainWindow, public Ui_BCMainWindow
{
  Q_OBJECT

public:

  BCMainWindow(QWidget *parent = nullptr);
  virtual ~BCMainWindow();

public slots:

  //void onValueListReady( BCDevice::ID deviceID );
  void onShowDevicePanel( BCDevice::ID deviceID );
  void onActionButtonTriggered( bool checked);
  void onActionButtonToggled( bool checked);
  void onConnectButtonToggled(bool active );

  // Slots für Rückmeldungen vom Runner
  void onValueUpdated( BCDevice::ID deviceID, int index, BC::State state, const QString& newValue="" );
  void onRunnerMessage(const QString &msg);
  void onSyncFromDevice();

signals:

  // Internes Signal, um Daten an den Worker Thread zu senden
  void sendValueCommand( BC::OpID, const BCValue* cmd);
  //void valuedTouched(const BCValue& cmd);
  void valueTouched(int indexRow );

protected:

  void initMainWindow();

  BCDataManager _dataManager;

  // Wir brauchen eine Verbindung zwischen den Views
  // und dem Device, das sie darstellen.

  using BCDeviceViews = QHash<BCDevice::ID, BCDeviceView*>;
  BCDeviceViews   _devicePanels;
  BCDeviceView*   _currentPanel{};

  QThread          _worker;
  BCTransmitter    _transmitter;
};

#endif // BCMAINWINDOW_H
